<script setup lang="ts">
import { useAuthStore } from '@/stores/auth'
import type { OrderReceipt, status } from '@/types/OrderReceipt'
import type { OrderReceiptItem } from '@/types/OrderReceiptItem'
import { computed, nextTick, ref } from 'vue'
import { onMounted } from 'vue'
import type { VForm } from 'vuetify/components'

const authStore = useAuthStore()

const orderReceipts = ref<OrderReceipt>({
  id: -1,
  orderDate: new Date(),
  receiveDate: new Date(''),
  totalQty: 0,
  totalPrice: 0,
  statusOrder: ['waiting for shipment'],
  employeeId: authStore.currantUser.id,
  employee: authStore.currantUser
})

const orderReceiptsTable = ref<OrderReceipt[]>([])
const headers = [
  {
    title: 'Id',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Order Date',
    key: 'orderDate',
    value: 'orderDate'
  },
  {
    title: 'Receive Date',
    key: 'receiveDate',
    value: 'receiveDate'
  },
  {
    title: 'Total Qty',
    key: 'totalQty',
    value: 'totalQty'
  },
  {
    title: 'Total Price',
    key: 'totalPrice',
    value: (item: OrderReceipt) => item.totalPrice.toFixed(2)
  },
  {
    title: 'Status Order',
    key: 'statusOrder',
    value: (item: any | status) => item.statusOrder.join(', ')
  },
  {
    title: 'EMP ID',
    key: 'employeeId',
    value: 'employeeId'
  },
  { title: '', key: 'actions', sortable: false }
]

const orderReceiptItems = ref<OrderReceiptItem[]>([])

function initializeOrderStockTable() {
  orderReceiptsTable.value = [
    {
      id: 1,
      orderDate: new Date('2024-01-03'),
      receiveDate: new Date('2024-01-06'),
      totalQty: 100,
      totalPrice: 1000,
      statusOrder: ['delivered'],
      employeeId: 1,
      employee: {
        id: 1,
        email: 'mana123@gmail.com',
        password: 'pass123',
        fullname: 'John Leider',
        gender: 'male',
        roles: ['admin']
      },
      orderReceiptItem: [
        {
          id: -1,
          name: 'blue berry',
          price: 500,
          qty: 50
        },
        {
          id: -1,
          name: 'black berry',
          price: 500,
          qty: 50
        }
      ]
    },
    {
      id: 2,
      orderDate: new Date('2024-01-05'),
      receiveDate: new Date('2024-01-05'),
      totalQty: 70,
      totalPrice: 700,
      statusOrder: ['waiting for shipment'],
      employeeId: 1,
      employee: {
        id: 1,
        email: 'mana123@gmail.com',
        password: 'pass123',
        fullname: 'John Leider',
        gender: 'male',
        roles: ['admin']
      },
      orderReceiptItem: [
        {
          id: -1,
          name: 'Sugar',
          price: 400,
          qty: 40
        },
        {
          id: -1,
          name: 'Syrup',
          price: 300,
          qty: 30
        }
      ]
    }
  ]
}
onMounted(() => {
  initializeOrderStockTable()
})

const initialOrderReceipt: OrderReceipt = {
  id: -1,
  orderDate: new Date(),
  receiveDate: new Date(''),
  totalQty: 0,
  totalPrice: 0,
  statusOrder: ['waiting for shipment'],
  employeeId: authStore.currantUser.id,
  employee: authStore.currantUser
}

const initialOrderReceiptItems: OrderReceiptItem = {
  id: -1,
  name: '',
  price: 0,
  qty: 0
}

const editedOrderReceiptItem = ref<OrderReceiptItem>(
  JSON.parse(JSON.stringify(initialOrderReceiptItems))
)
const editedOrderReceipt = ref<OrderReceipt>(JSON.parse(JSON.stringify(initialOrderReceipt)))
const search = ref('')
const dialog = ref(false)
const dialogDelete = ref(false)
const dialogEdited = ref(false)
const refForm = ref<VForm | null>(null)
const form = ref(false)
const loading = ref(false)
const divOrderReceiptItems = ref<HTMLElement | null>(null)
const dialogShowOrderReceiptItems = ref(false)
const dialogReceiveOrder = ref(false)
const isOpenOrderDate = ref(false)
const isOpenReceiveDate = ref(false)
let editedIndex = -1
let lastId = 3

const filteredOrderStock = computed(() => {
  return orderReceiptsTable.value.filter(
    (orderReceiptsTable) =>
      orderReceiptsTable.orderDate?.toLocaleDateString().includes(search.value)
  )
})

function onSubmit() {}

function closeDialog() {
  dialog.value = false
  dialogShowOrderReceiptItems.value = false
  dialogEdited.value = false
  nextTick(() => {
    editedOrderReceipt.value = Object.assign({}, initialOrderReceipt)
    editedIndex = -1
  })
  clearOrderReceipt()
  clearReceiptItems()
}

async function addReceiptItems() {
  const { valid } = await refForm.value!.validate()

  if (!valid) return
  const newOrderReceipt: OrderReceiptItem = {
    id: -1,
    name: editedOrderReceiptItem.value.name,
    price: editedOrderReceiptItem.value.price,
    qty: editedOrderReceiptItem.value.qty
  }

  for (const item of orderReceiptItems.value) {
    if (item.name.toUpperCase() === editedOrderReceiptItem.value.name.toUpperCase()) return
  }
  orderReceiptItems.value.push(newOrderReceipt)
  clearReceiptItems()
  calculate()
  nextTick(() => {
    if (divOrderReceiptItems.value)
      divOrderReceiptItems.value.scrollTo(0, divOrderReceiptItems.value.scrollHeight)
  })
}

function clearReceiptItems() {
  editedOrderReceiptItem.value.id = -1
  editedOrderReceiptItem.value.name = ''
  editedOrderReceiptItem.value.price = 0
  editedOrderReceiptItem.value.qty = 0
}

function calculate() {
  let totalPrice = 0
  for (const item of orderReceiptItems.value) {
    totalPrice += item.price
  }
  let totalQty = 0
  for (const item of orderReceiptItems.value) {
    totalQty += item.qty
  }
  orderReceipts.value.totalQty = totalQty
  orderReceipts.value.totalPrice = totalPrice
}

function save() {
  if (editedIndex > -1) {
    Object.assign(orderReceiptsTable.value[editedIndex], editedOrderReceipt.value)
  } else {
    if (orderReceipts.value.totalQty === 0) {
      return
    }
    orderReceipts.value.orderReceiptItem = orderReceiptItems.value
    orderReceipts.value.id = lastId++
    orderReceiptsTable.value.push(orderReceipts.value)
  }
  clearOrderReceipt()
  closeDialog()
}

function editedOrderReceiptDialog(item: OrderReceipt) {
  editedIndex = orderReceiptsTable.value.indexOf(item)
  editedOrderReceipt.value = Object.assign({}, item)
  dialogEdited.value = true
}

function clearOrderReceipt() {
  orderReceiptItems.value = []
  orderReceipts.value = {
    id: -1,
    orderDate: new Date(),
    receiveDate: new Date(),
    totalQty: 0,
    totalPrice: 0,
    statusOrder: ['waiting for shipment'],
    employeeId: 1
  }
}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedOrderReceipt.value = Object.assign({}, initialOrderReceipt)
  })
}
function deleteItemConfirm() {
  //  Delete item from list
  orderReceiptsTable.value.splice(editedIndex, 1)
  closeDelete()
  editedIndex = -1
}
function deleteItem(item: OrderReceipt) {
  editedIndex = orderReceiptsTable.value.indexOf(item)
  editedOrderReceipt.value = Object.assign({}, item)
  dialogDelete.value = true
}

function showOrderReceiptItems(item: OrderReceipt) {
  editedIndex = orderReceiptsTable.value.indexOf(item)
  editedOrderReceipt.value = Object.assign({}, item)
  dialogShowOrderReceiptItems.value = true
}

function removeOrderReceiptItems(orderReceiptItem: OrderReceiptItem) {
  const index = orderReceiptItems.value.findIndex((item) => item === orderReceiptItem)
  orderReceiptItems.value.splice(index, 1)
  calculate()
}

function orderStockReceiveConfirm() {
  if (editedOrderReceipt.value.statusOrder.includes('delivered')) {
    return
  }
  editedOrderReceipt.value.receiveDate = new Date()
  editedOrderReceipt.value.statusOrder = ['delivered']
  Object.assign(orderReceiptsTable.value[editedIndex], editedOrderReceipt.value)
  closeReceiveOrderConfirm()
  editedIndex = -1
}

function getColorStatusOrder(status: status) {
  if (status === 'delivered') {
    return 'green'
  } else {
    return 'red'
  }
}

function closeReceiveOrderConfirm() {
  dialogReceiveOrder.value = false
  nextTick(() => {
    editedOrderReceipt.value = Object.assign({}, initialOrderReceipt)
  })
}

function receiveOrder(item: OrderReceipt) {
  editedIndex = orderReceiptsTable.value.indexOf(item)
  editedOrderReceipt.value = Object.assign({}, item)
  dialogReceiveOrder.value = true
}
</script>

<template>
  <div style="width: 95%; height: 100%">
    <v-card-title class="d-flex align-center pe-2">
      <v-spacer></v-spacer>
    </v-card-title>
    <v-data-table :headers="headers" :items="filteredOrderStock">
      <template v-slot:[`item.orderDate`]="{ value }">
        {{ value.toLocaleDateString('en-GB') }}
      </template>
      <template v-slot:[`item.receiveDate`]="{ value }">
        {{
          value && !isNaN(new Date(value).getTime())
            ? new Date(value).toLocaleDateString('en-GB')
            : ''
        }}
      </template>
      <template v-slot:[`item.statusOrder`]="{ value }">
        <div class="text-start">
          <v-chip :color="getColorStatusOrder(value)" class="text-uppercase" label size="small">
            {{ value }}
          </v-chip>
        </div>
      </template>
      <template v-slot:top>
        <v-toolbar flat color="#F48FB1">
          <v-toolbar-title>
            <v-icon icon="mdi-truck-delivery"> </v-icon> Order Stock</v-toolbar-title
          >
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <!--orderReceipt Dialog-->
          <v-dialog v-model="dialog" persistent width="1440" height="800">
            <template v-slot:activator="{ props }">
              <v-btn color="#ECEFF1" variant="flat" v-bind="props">
                <v-icon icon="mdi-plus"> </v-icon>
                New OrderReceipt
              </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Receipt Items</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="editedOrderReceiptItem.name"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Name"
                          placeholder="Enter your Item Name"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          type="number"
                          v-model.number="editedOrderReceiptItem.qty"
                          :readonly="loading"
                          :rules="[(v) => v >= 0]"
                          class="mb-2"
                          clearable
                          label="QTY"
                          placeholder="Enter your QTY"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          type="number"
                          v-model.number="editedOrderReceiptItem.price"
                          :readonly="loading"
                          :rules="[(v) => v >= 0]"
                          class="mb-2"
                          clearable
                          label="Price"
                          placeholder="Enter your Price"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                  <v-card-actions aria-label="right">
                    <v-btn color="green" variant="flat" @click="addReceiptItems">ADD</v-btn>
                    <v-btn color="red" variant="flat" @click="clearReceiptItems">Cancel</v-btn>
                  </v-card-actions>
                </v-form>
                <small>*indicates required field</small>

                <div ref="divOrderReceiptItems" style="height: 400; overflow: auto">
                  <v-sheet min-width="400" max-width="1340" height="400" elevation="4">
                    <v-table>
                      <template v-slot:default>
                        <thead>
                          <tr>
                            <th>#</th>
                            <th>name</th>
                            <th>qty</th>
                            <th>price</th>
                            <th></th>
                          </tr>
                        </thead>
                        <tbody>
                          <tr v-for="(item, index) of orderReceiptItems" :key="item.id">
                            <td>{{ index + 1 }}</td>
                            <td>{{ item.name }}</td>
                            <td>{{ item.qty }}</td>
                            <td>{{ item.price }}</td>
                            <td>
                              <v-btn
                                icon="mdi-delete"
                                density="compact"
                                @click="
                                  () => {
                                    removeOrderReceiptItems(item)
                                  }
                                "
                              ></v-btn>
                            </td>
                          </tr>
                        </tbody>
                      </template>
                    </v-table>
                  </v-sheet>
                </div>
              </v-card-text>

              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="red" variant="flat" @click="closeDialog"> Close </v-btn>
                <v-btn color="green" variant="flat" @click="save"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-text-field
            class="mx-2"
            v-model="search"
            prepend-inner-icon="mdi-magnify"
            density="compact"
            label="Search"
            single-line
            flat
            hide-details
            variant="outlined"
          ></v-text-field>
          <!-- dialog delete -->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5"
                >Are you sure you want to delete this item?</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <!-- dialog editedDate -->
          <v-dialog v-model="dialogEdited" persistent width="450">
            <v-card>
              <v-card-title>
                <span class="text-h5">Order Receipt Date</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <div style="width: 90%">
                    <v-container>
                      <v-menu v-model="isOpenOrderDate" :close-on-content-click="false">
                        <template v-slot:activator="{ props }">
                          <v-text-field
                            class="py-2"
                            label="Order Date"
                            prepend-icon="mdi-calendar-range"
                            :model-value="editedOrderReceipt.orderDate?.toLocaleDateString('en-GB')"
                            readonly
                            v-bind="props"
                            variant="solo"
                            hide-details
                          ></v-text-field>
                        </template>
                        <v-date-picker
                          v-model="editedOrderReceipt.orderDate"
                          hide-actions
                          title="Please Select Order Date"
                        >
                          <template v-slot:header></template>
                        </v-date-picker>
                      </v-menu>
                      <v-menu v-model="isOpenReceiveDate" :close-on-content-click="false">
                        <template v-slot:activator="{ props }">
                          <v-text-field
                            class="py-2"
                            label="Receive Date"
                            prepend-icon="mdi-calendar-range"
                            :model-value="
                              editedOrderReceipt.receiveDate?.toLocaleDateString('en-GB')
                            "
                            readonly
                            v-bind="props"
                            variant="solo"
                            hide-details
                          ></v-text-field>
                        </template>
                        <v-date-picker
                          v-model="editedOrderReceipt.receiveDate"
                          hide-actions
                          title="Please Select Receive Date"
                        >
                          <template v-slot:header></template>
                        </v-date-picker>
                      </v-menu>
                    </v-container>
                  </div>
                </v-form>
                <small>*Please Select Date</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="red" variant="flat" @click="closeDialog"> Close </v-btn>
                <v-btn color="green" variant="flat" @click="save"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <!-- showOrderReceiptItems -->
          <v-dialog v-model="dialogShowOrderReceiptItems" width="520" height="800" persistent>
            <v-card>
              <v-card-title class="text-h5">OrderReceipt Item</v-card-title>
              <div style="margin: 10px">
                <v-spacer></v-spacer>
                <td>
                  วันที่สั่งสินค้า: {{ editedOrderReceipt.orderDate?.toLocaleDateString('en-GB') }}
                </td>
                <v-spacer></v-spacer>
                <td>ผู้ซื้อสินค้า: {{ editedOrderReceipt.employee?.fullname }}</td>
                <v-spacer></v-spacer>
                <v-card-text>
                  <v-table>
                    <template v-slot:default>
                      <thead>
                        <tr>
                          <th>#</th>
                          <th>name</th>
                          <th>qty</th>
                          <th>price</th>
                        </tr>
                      </thead>
                      <tbody>
                        <tr
                          v-for="(item, index) of editedOrderReceipt.orderReceiptItem"
                          :key="item.id"
                        >
                          <td>{{ index + 1 }}</td>
                          <td>{{ item.name }}</td>
                          <td>{{ item.qty }}</td>
                          <td>{{ item.price.toFixed(2) }}</td>
                        </tr>
                      </tbody>
                    </template>
                  </v-table>
                  <td>จำนวนสินค้าทั้งหมด:{{ editedOrderReceipt.totalQty }} Unit</td>
                  <v-spacer></v-spacer>
                  <td>ยอดเงินรวม:{{ editedOrderReceipt.totalPrice.toFixed(2) }} Baht</td>
                </v-card-text>
              </div>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="red" variant="flat" @click="closeDialog"> Close </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <!-- confirm Receive Order -->
          <v-dialog v-model="dialogReceiveOrder" max-width="500px">
            <v-card>
              <v-card-title class="text-h5">Are you sure you receive this order?</v-card-title>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeReceiveOrderConfirm"
                  >Cancel</v-btn
                >
                <v-btn color="blue-darken-1" variant="text" @click="orderStockReceiveConfirm"
                  >OK</v-btn
                >
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-menu>
          <template v-slot:activator="{ props }">
            <v-btn v-bind="props" class="mr-2" size="small" variant="flat" elevation="6">
              <v-icon>mdi-dots-horizontal</v-icon>
            </v-btn>
          </template>

          <v-card>
            <v-list>
              <v-list-item @click="receiveOrder(item)">
                <v-icon size="small" class="me-2">mdi-truck-delivery</v-icon>
                Receive Order
              </v-list-item>
              <v-list-item @click="editedOrderReceiptDialog(item)">
                <v-icon size="small" class="me-2">mdi-pencil</v-icon>
                Edit
              </v-list-item>
              <v-list-item @click="showOrderReceiptItems(item)">
                <v-icon> mdi-receipt-text</v-icon>
                OrderReceipt Items
              </v-list-item>
              <v-list-item @click="deleteItem(item)">
                <v-icon> mdi-delete</v-icon>
                Delete
              </v-list-item>
            </v-list>
          </v-card>
        </v-menu>
      </template>
    </v-data-table>
  </div>
</template>
